
Settings = 
{
	Name = "xSarATR",

	periodATR =21,
	
	ddd=3,
	line=
	{
		{
			Name = "xSarATR",
			Color = RGB(0, 192, 0),
			Type = TYPET_BAR,
			Width = 2
		},
		{
			Name = "xSarATR",
			Color = RGB(192, 0, 0),
			Type =  TYPET_BAR,
			Width = 2
		}
	,
		{
			Name = "xSarATR",
			Color = RGB(0, 0, 255),
			Type = TYPE_TRIANGLE_UP,
			Width = 3
		}
	,
		{
			Name = "xSarATR",
			Color = RGB(255, 0, 0),
			Type = TYPE_TRIANGLE_DOWN,
			Width = 3
		}
	}
}

---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
function cached_SAR()
	local cache_H={}
	local cache_L={}
	local cache_SAR={}
	local cache_ST={}
	local AMA2={}
	local CC={}
	local CC_N={}	
	local ATR={}
	
	return function(ind,  _p4,_ddd)

		local index = ind
		local ZZZ = 0
				
		if index == 1 then
			cache_H={}
			cache_L={}
			cache_SAR={}
			cache_ST={}
			AMA2={}
			CC={}
			CC_N={}
			ATR={}

------------------
			CC[index]=C(index)
			CC_N[index]=(C(index)+H(index)+L(index))/3
			cache_H[index]=H(index)
			cache_L[index]=L(index)
			cache_SAR[index]=L(index)-2*(H(index)-L(index))
			AMA2[index]=(C(index)+O(index))/2
			cache_ST[index]=1
			ATR[index]=math.abs(H(index)-L(index))
			return nil
		end
		------------------------------
			ZZZ=math.max(math.abs(H(index)-L(index)),math.abs(H(index)-C(index-1)),math.abs(L(index)-C(index-1)))
			ATR[index]=(ATR[index-1]*(_p4-1)+ZZZ)/_p4
			cache_SAR[index]=cache_SAR[index-1]
			CC[index]=C(index)
			AMA2[index]=(2/(_p4/2+1))*CC[index]+(1-2/(_p4/2+1))*AMA2[index-1]
			CC_N[index]=(C(index)-AMA2[index])/2+AMA2[index]
			cache_ST[index]=cache_ST[index-1]
			cache_H[index]=cache_H[index-1] 
			cache_L[index]=cache_L[index-1]
---------------------------------------------------------------------------------------
		if index ==2 then
			return nil
		end
----------------------------------------------------------------------		
		if cache_ST[index]==1 then
				
				if cache_H[index] < CC[index] then 
					cache_H[index]=CC[index]
				end
			cache_SAR[index]=math.max((cache_H[index]-ATR[index]*_ddd),cache_SAR[index-1])
			if (cache_SAR[index] > CC_N[index])and(cache_SAR[index] > C(index)) then 
				cache_ST[index]=0
				cache_L[index]=CC[index]
				cache_SAR[index]=cache_L[index]+ATR[index]*_ddd*1
				return  nil,cache_SAR[index],  nil,cache_H[index]-ATR[index]*_ddd
			end
			return cache_SAR[index], nil, nil, nil
		end
---------------------------------------------------------------------------------------
		if cache_ST[index]==0 then
				if cache_L[index] > CC[index] then 
					cache_L[index]=CC[index]
				end
			cache_SAR[index]=math.min((cache_L[index]+ATR[index]*_ddd),cache_SAR[index-1])
			if (cache_SAR[index] < CC_N[index])and (cache_SAR[index] < C(index)) then 
				cache_ST[index]=1
				cache_H[index]=CC[index]
				cache_SAR[index]=cache_H[index]-ATR[index]*_ddd*1
				return cache_SAR[index], nil, cache_L[index]+ATR[index]*_ddd,nil
			end
		return nil,cache_SAR[index],  nil, nil
		end


	end
end
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------

function Init()
	mySAR = cached_SAR()
	return 4
end
function OnCalculate(index)
	return mySAR(index, Settings.periodATR,Settings.ddd)
end